var _gt_visible = false;
var _friends_offset = 0;

var _friends_scrollanim = 0;
var _friends_scrollanim_value = 0;

var _show_hide_list_anim = 0;
var _show_hide_list_anim_value = 0;

var _friends = new Array();

var _friends_list_length = 5;

var _check_for_online_friends = 0;

// called from within main.js -> view_onopen(), to init this "module"
function GoogleTalkOnOpen() {
  if (googleTalk.friends.toArray().length == 0) {
    send_to_button.visible = false;
  }
  _check_for_online_friends_timer = setInterval("OnCheckOnlinesTimer()", 10000);  //check every 10 sec.
}

// check for online friends
function OnCheckOnlinesTimer() {
  // if no friends are online, hide the "send to..." button
  if (googleTalk.friends.toArray().length == 0) {
    send_to_button.visible = false;
  }
  else {  // show "send to..." button
    send_to_button.visible = true;
    if (_gt_visible) {  // if module is visible, repopulate list (remove offline friends, change status);
      PopulateList(_friends_offset);
    }
  }
}

// if "send to..." button is clicked, show/hide and init list
function send_to_button_onclick() {
  //visibility toggle
  _gt_visible = !_gt_visible;

  _friends_offset = 0;
  _friends_scrollanim_value = 0;
  
  if (_show_hide_list_anim != 0) {
    view.cancelAnimation(_show_hide_list_anim);
  }
  
  if (_gt_visible) {  //show
    gt_pane.visible = true;
    //populate list
    PopulateList(_friends_offset);
    //show list animation
    _show_hide_list_anim = view.beginAnimation("ShowHideListAnimation()", _show_hide_list_anim_value, 255, 255 - _show_hide_list_anim_value);  
  }
  else {  //hide
    _show_hide_list_anim = view.beginAnimation("ShowHideListAnimation()", _show_hide_list_anim_value, 0, _show_hide_list_anim_value);  
  }
}

// Show/Hide Animation 
function ShowHideListAnimation() {
  _show_hide_list_anim_value = Math.round(event.value);
  gt_pane.opacity = _show_hide_list_anim_value;
  if (_show_hide_list_anim_value == 0 && !_gt_visible) {
    gt_pane.visible = false;
  }
}

// populate list with online friends
function PopulateList(offset) {
  google_talk_scroll_up_button.enabled = true;
  google_talk_scroll_down_button.enabled = true;

  _friends = new Array();
  _friends = googleTalk.friends.toArray();

  // check offset value for validity
  if (Math.max(0, _friends.length - _friends_list_length) < offset) {
    _friends_offset = Math.max(0, _friends.length - _friends_list_length);
    offset = _friends_offset;
  }

  // check if fewer friends than list length (5) are online, 
  // and handle label visibilities and scroll buttons
  if (_friends.length <= _friends_list_length) {
    google_talk_scroll_up_button.enabled = false;
    google_talk_scroll_down_button.enabled = false;
    
    friend_div_1.visible = false;
    friend_div_2.visible = false;
    friend_div_3.visible = false;
    friend_div_4.visible = false;
    friend_div_5.visible = false;
    if (_friends.length > 0) {
      friend_div_1.visible = true;
    }
    if (_friends.length > 1) {
      friend_div_2.visible = true;
    }
    if (_friends.length > 2) {
      friend_div_3.visible = true;
    }
    if (_friends.length > 3) {
      friend_div_4.visible = true;
    }
    if (_friends.length > 4) {
      friend_div_5.visible = true;
    }
  }

  //set labels & status icons
  if (_friends.length > 0) {
    friend_div_1.tooltip = SEND_TO_TOOLTIP.replace(/\.+$/, " ") + _friends[offset].name; 
    friend_1.innerText = _friends[offset].name;
    switch (_friends[offset].status) {
      case gddFriendStatusOnline:
        friend_status_1.src = "status_online.png";
        break;
      case gddFriendStatusIdle:
        friend_status_1.src = "status_idle.png";
        break;
      case gddFriendStatusBusy:
        friend_status_1.src = "status_busy.png";
        break;
      default:
        friend_status_1.src = "status_busy.png";
        break;
    }
  }
  if (_friends.length > 1) {
    friend_div_2.tooltip = SEND_TO_TOOLTIP.replace(/\.+$/, " ") + _friends[offset + 1].name; 
    friend_2.innerText = _friends[offset + 1].name;
    switch (_friends[offset + 1].status) {
      case gddFriendStatusOnline:
        friend_status_2.src = "status_online.png";
        break;
      case gddFriendStatusIdle:
        friend_status_2.src = "status_idle.png";
        break;
      case gddFriendStatusBusy:
        friend_status_2.src = "status_busy.png";
        break;
      default:
        friend_status_2.src = "status_busy.png";
      break;
    }
  }
  if (_friends.length > 2) {
    friend_div_3.tooltip = SEND_TO_TOOLTIP.replace(/\.+$/, " ") + _friends[offset + 2].name; 
    friend_3.innerText = _friends[offset + 2].name;
    switch (_friends[offset + 2].status) {
      case gddFriendStatusOnline:
        friend_status_3.src = "status_online.png";
        break;
      case gddFriendStatusIdle:
        friend_status_3.src = "status_idle.png";
        break;
      case gddFriendStatusBusy:
        friend_status_3.src = "status_busy.png";
        break;
      default:
        friend_status_3.src = "status_busy.png";
        break;
    }
  }
  if (_friends.length > 3) {
    friend_div_4.tooltip = SEND_TO_TOOLTIP.replace(/\.+$/, " ") + _friends[offset + 3].name; 
    friend_4.innerText = _friends[offset + 3].name;
    switch (_friends[offset + 3].status) {
      case gddFriendStatusOnline:
        friend_status_4.src = "status_online.png";
        break;
      case gddFriendStatusIdle:
        friend_status_4.src = "status_idle.png";
        break;
      case gddFriendStatusBusy:
        friend_status_4.src = "status_busy.png";
        break;
      default:
        friend_status_4.src = "status_busy.png";
        break;
    }
  }
  if (_friends.length > 4) {
    friend_div_5.tooltip = SEND_TO_TOOLTIP.replace(/\.+$/, " ") + _friends[offset + 4].name; 
    friend_5.innerText = _friends[offset + 4].name;
    switch (_friends[offset + 4].status) {
      case gddFriendStatusOnline:
        friend_status_5.src = "status_online.png";
        break;
      case gddFriendStatusIdle:
        friend_status_5.src = "status_idle.png";
        break;
      case gddFriendStatusBusy:
        friend_status_5.src = "status_busy.png";
        break;
      default:
        friend_status_5.src = "status_busy.png";
        break;
    }
  }
}

function google_talk_close_onclick() {
  _gt_visible = false;

  _show_hide_list_anim = view.beginAnimation("ShowHideListAnimation()", _show_hide_list_anim_value, 0, _show_hide_list_anim_value);  
}

function google_talk_scroll_up_onmousedown() {
  // first scroll step manually
  _friends_offset = (_friends_offset>0 ? _friends_offset-1 : 0);
  PopulateList(_friends_offset);
  _friends_scrollanim_value = _friends_offset;

  //start scroll animation
  _friends_scrollanim = view.beginAnimation("FriendsScrollAnimation()", _friends_scrollanim_value, 0, 150 * _friends_scrollanim_value);
}

function google_talk_scroll_up_onmouseup() {
  if (_friends_scrollanim != 0) {
    view.cancelAnimation(_friends_scrollanim);
  }
}

function google_talk_scroll_down_onmousedown() {
  // first scroll step manually
  _friends_offset = (_friends_offset < Math.max(0,_friends.length - _friends_list_length) ? _friends_offset+1 : Math.max(0,_friends.length - _friends_list_length));
  PopulateList(_friends_offset);
  _friends_scrollanim_value = _friends_offset;

  //start scroll animation
  _friends_scrollanim = view.beginAnimation("FriendsScrollAnimation()", _friends_scrollanim_value, Math.max(0,_friends.length - _friends_list_length), 150 * (Math.max(0,_friends.length - _friends_list_length) - _friends_scrollanim_value));  
}

function google_talk_scroll_down_onmouseup() {
  if (_friends_scrollanim != 0) {
    view.cancelAnimation(_friends_scrollanim);
  }
}

function FriendsScrollAnimation() {
  _friends_scrollanim_value = Math.floor(event.value);
  if (_friends_offset != _friends_scrollanim_value) {
    _friends_offset = _friends_scrollanim_value;
    PopulateList(_friends_offset);
  }
}

// event handler for friend_div's

function friend_div_1_onmouseover() {
  friend_div_1.background="#44FFFFFF";
}
function friend_div_2_onmouseover() {
  friend_div_2.background="#44FFFFFF";
}
function friend_div_3_onmouseover() {
  friend_div_3.background="#44FFFFFF";
}
function friend_div_4_onmouseover() {
  friend_div_4.background="#44FFFFFF";
}
function friend_div_5_onmouseover() {
  friend_div_5.background="#44FFFFFF";
}

function friend_div_1_onmouseout() {
  friend_div_1.background="#22FFFFFF";
}
function friend_div_2_onmouseout() {
  friend_div_2.background="#22FFFFFF";
}
function friend_div_3_onmouseout() {
  friend_div_3.background="#22FFFFFF";
}
function friend_div_4_onmouseout() {
  friend_div_4.background="#22FFFFFF";
}
function friend_div_5_onmouseout() {
  friend_div_5.background="#22FFFFFF";
}

function friend_div_1_onmousedown() {
  friend_div_1.background="#66FFFFFF";
}
function friend_div_2_onmousedown() {
  friend_div_2.background="#66FFFFFF";
}
function friend_div_3_onmousedown() {
  friend_div_3.background="#66FFFFFF";
}
function friend_div_4_onmousedown() {
  friend_div_4.background="#66FFFFFF";
}
function friend_div_5_onmousedown() {
  friend_div_5.background="#66FFFFFF";
}

function  friend_div_1_onclick() {
  friend_div_1.background="#44FFFFFF";
  // send data to friend IM
  googleTalk.SendTalkText(_friends[_friends_offset].user_id, BuildMessage());
}

function  friend_div_2_onclick() {
  friend_div_2.background="#44FFFFFF";
  // send data to friend IM
  googleTalk.SendTalkText(_friends[_friends_offset + 1].user_id, BuildMessage());
}

function  friend_div_3_onclick() {
  friend_div_3.background="#44FFFFFF";
  // send data to friend IM
  googleTalk.SendTalkText(_friends[_friends_offset + 2].user_id, BuildMessage());
}

function  friend_div_4_onclick() {
  friend_div_4.background="#44FFFFFF";
  // send data to friend IM
  googleTalk.SendTalkText(_friends[_friends_offset + 3].user_id, BuildMessage());
}

function  friend_div_5_onclick() {
  friend_div_5.background="#44FFFFFF";
  // send data to friend IM
  googleTalk.SendTalkText(_friends[_friends_offset + 4].user_id, BuildMessage());
}

function BuildMessage() {
  return IM_MESSAGE.replace(/\n/, "\n" + title_link.innerText + "\n");
}
