options.DefaultValue("opacity") = 255;
options.DefaultValue("version") = "1.5.0.1";

var _title = "";
var _description = "";

var _reload_timer = 0;
var _extended = false;
var _collapseextendanim = 0;
var _collapseextendanim_value = 0;

var _scrollanim = 0;
var _scrollanim_value = 0;

plugin.onAddCustomMenuItems = AddCustomMenuItems; 

function AddCustomMenuItems(menu) { 
  menu.AddItem(RELOAD_MENU, 0, OnMenuItem_Refresh);
}

function OnMenuItem_Refresh(item_text) {
  LoadAPOD();  
}

function view_onopen() {
  main_div.opacity = options("opacity");
  version.innerText = VERSION + " " + options("version");
  GoogleTalkOnOpen();
  LoadAPOD();  
  _reload_timer = setInterval("OnReloadTimer()", 24*60*60*1000);  //reload every 24h
}

function view_onoptionchanged() {
  main_div.opacity = options("opacity");
}

function OnReloadTimer() {
  LoadAPOD();  
}

function LoadAPOD() {  // Load "Astronomy Picture of the Day" Data
  progress_div.visible = true;
  LoadImage();
  LoadDescription();
  load_progress.value = 0;
  progress_div.visible = false;
}

function LoadImage() {
  var http = new XMLHttpRequest(); 
  var url = "http://antwrp.gsfc.nasa.gov/apod/calendar/today.jpg"; 
  http.onreadystatechange = onData; 
  http.open("GET", url, "true"); 
  http.send(); 
  function onData() { 

    switch (http.readyState) {  // handle progressbar
      case 1:
        load_progress.value = 12;
        break;
      case 2:
        load_progress.value = 25;
        break;
      case 3:
        load_progress.value = 37;
        break;
      case 4:
        load_progress.value = 50;
        break;
      default:
        break;
    }

    if (http.readyState == 4) { 
      if (http.status == 200) {
        var source = http.responseStream; 
        astronomy_picture.src = source; 
        //change width/height to keep aspect ratio
        if (astronomy_picture.srcHeight / astronomy_picture.srcWidth > 0.75) {
          //scale on height
          astronomy_picture.height = 225;
          astronomy_picture.width = astronomy_picture.srcWidth * 225 / astronomy_picture.srcHeight;
          astronomy_picture.x = 25 + (300-astronomy_picture.width)/2;
        }
        else {
          //scale on width
          astronomy_picture.width = 300;
          astronomy_picture.height = astronomy_picture.srcHeight * 300 / astronomy_picture.srcWidth;
          astronomy_picture.y = 25 + (200-astronomy_picture.height)/2;
        }
      }
      else { // status != 200
        astronomy_picture.src = "astronomy_picture.png"; 
      }
    } 
  }
}

function LoadDescription() {
  var http = new XMLHttpRequest(); 
  var url = "http://antwrp.gsfc.nasa.gov/apod/astropix.html"; 
  http.onreadystatechange = onData; 
  http.open("GET", url, "true"); 
  http.send(); 

  function onData() { 
    switch (http.readyState) {  // handle progressbar
      case 1:
        load_progress.value = 62;
        break;
      case 2:
        load_progress.value = 75;
        break;
      case 3:
        load_progress.value = 87;
        break;
      case 4:
        load_progress.value = 100;
        break;
      default:
        break;
    }

    if (http.readyState == 4) { 
      if (http.status == 200) {
        //Title - find and format title
        var start = http.responseText.indexOf("<b>");
        var end = http.responseText.indexOf("</b>");
        if (start != -1 && end != -1) {
          _title = http.responseText.substr(start+3, end-start-3);
          _title = _title.replace(/^\s+/, "");
          _title = _title.replace(/\s+$/, "");
          title_link.innerText = _title;
        }
        else {
          title_link.innerText = ERROR_LOADING;
        }
        
        //Description - find and format description
        var start = http.responseText.indexOf("<b> Explanation: </b>");
        var end = http.responseText.indexOf("<p> <center>");
        if (start != -1 && end != -1) {
          _description = http.responseText.substr(start+21, end-start-21);
          _description = _description.replace(/^\s+/, "");
          _description = _description.replace(/\s+$/, "");
          _description = _description.replace(/\s+/g, " ");
          _description = _description.replace(/<.+?>/g, "");
          description.innerText = _title + "\n\n" + _description;
        }
        else {
          description.innerText = ERROR_LOADING;
        }
      }
      else { // status != 200
        title_link.innerText = ERROR_LOADING;
        description.innerText = ERROR_LOADING;
      }
    } 
  }
}

function collapse_extend_button_clicked() {
  _extended = !_extended;
  if (!desc_pane.visible) {
    desc_pane.visible = true;
  }
  if (_collapseextendanim != 0) {
    view.cancelAnimation(_collapseextendanim);
  }
  if (_extended) {
    collapse_extend_button.image = "collapse_normal.png";
    collapse_extend_button.overImage = "collapse_over.png";
    collapse_extend_button.downImage = "collapse_down.png";
    _collapseextendanim = view.beginAnimation("CollapseExtendAnimation()", _collapseextendanim_value, desc_pane.height, 2*(desc_pane.height - _collapseextendanim_value));
  }
  else {
    collapse_extend_button.image = "extend_normal.png";
    collapse_extend_button.overImage = "extend_over.png";
    collapse_extend_button.downImage = "extend_down.png";
    _collapseextendanim = view.beginAnimation("CollapseExtendAnimation()", _collapseextendanim_value, 0, 2*_collapseextendanim_value);
  }
}

function CollapseExtendAnimation() {
  _collapseextendanim_value = Math.round(event.value);
  desc_pane.y = 40 + _collapseextendanim_value;
  view.height = background.height + _collapseextendanim_value;
  main_div.height = background.height + _collapseextendanim_value;
  
  if (!_extended && _collapseextendanim_value == 0) {
    desc_pane.visible = false;
  }
}

function title_link_onmouseover() {
  title_link.tooltip = _title + " - " + TITLE_LINK_TOOLTIP;
}

function scroll_up_button_onmouseup() {
  if (_scrollanim != 0) {
    view.cancelAnimation(_scrollanim);
  }
}

function scroll_up_button_onmousedown() {
  _scrollanim = view.beginAnimation("ScrollAnimation()", _scrollanim_value, 0, 20*_scrollanim_value);
}

function scroll_down_button_onmouseup() {
  if (_scrollanim != 0) {
    view.cancelAnimation(_scrollanim);
  }
}

function scroll_down_button_onmousedown() {
  _scrollanim = view.beginAnimation("ScrollAnimation()", _scrollanim_value, description.height - label_div.height, 20 * (description.height - label_div.height - _scrollanim_value));
}

function ScrollAnimation() {
  _scrollanim_value = Math.round(event.value);
  description.y = -_scrollanim_value;
}